<!-- manual page source format generated by PolyglotMan v3.0.7, -->
<!-- available via anonymous ftp from ftp.cs.berkeley.edu:/ucb/people/phelps/tcltk/rman.tar.Z -->

<HTML>
<HEAD>
<TITLE>Man page for predep.1</TITLE>
</HEAD>
<BODY bgcolor=white>
<A HREF="#toc">Table of Contents</A><P>

<H2><A NAME="sect0" HREF="#toc0">Name</A></H2>

<P>
predep - preprocessing for the dependence analyzer

<H2><A NAME="sect1" HREF="#toc1"><B>Synopsis</B></A></H2>

<P>
<B>predep</B> <I>-normalize</I> | <I>-presc</I> [ <I>-verbose</I> ] <I>infile</I> <I>outfile</I> <I>...</I>

<H2><A NAME="sect2" HREF="#toc2"><B>Description</B></A></H2>

<P>
This pass performs two preprocessing steps that are useful
to the parallelizer.

<H2><A NAME="sect3" HREF="#toc3"><B>Options</B></A></H2>

<P>
<B>-presc</B> This preprocessing pass is needed by the <I>dependence</I>
<I>analyzer</I> to handle array accesses with symbolic
coefficients. Since the sign of the symbolic coefficient
affects the dependence, the code is modified
such that multiple loop nests are created for
symbolic coefficients. Three loop nests are created
for a symbolic coefficient such that the symbolic
coefficient is greater than zero, less than zero,
or equal to zero in each of the nests.

<DL>

<DT><B>-normalize</B></DT></DT>
<DD>
Normalize all the <I>TREE</I><B>_</B><I>FORs</I> by modifying all array
references and loop definitions so that the step is
always one and the loop test is always less-thanor-equal.
</DD>

<DT><B>-expand</B> <B>&lt;number&gt;</B></DT></DT>
<DD>
Maximum number of symbolic coefficients each loop
nest is expanded. The default is 2 symbolic coefficient.
After expanding for &lt;number&gt; symbolic
coefficient 2^&lt;number&gt; loop nests are created.
</DD>

<DT><B>-verbose</B></DT></DT>
<DD>
Print a detailed description on what is going on.
</DD>
</DL>

<H2><A NAME="sect4" HREF="#toc4"><B>History</B></A></H2>

<P>
The pass <I>predep</I> was written by Saman Amarasinghe. The
normalization code in the <I>dependence</I> <I>library</I> was originally
written by Dror Maydan and Michael Wolf and was
ported to new SUIF by Jennifer Anderson. The dependence
analysis of array accesses with symbolic coefficients in
the <I>dependence</I> <I>library</I> was written by Saman Amarasinghe.
<P>

<HR><P>
<A NAME="toc"><B>Table of Contents</B></A><P>
<UL>
<LI><A NAME="toc0" HREF="#sect0">Name</A></LI>
<LI><A NAME="toc1" HREF="#sect1">Synopsis</A></LI>
<LI><A NAME="toc2" HREF="#sect2">Description</A></LI>
<LI><A NAME="toc3" HREF="#sect3">Options</A></LI>
<LI><A NAME="toc4" HREF="#sect4">History</A></LI>
</UL>
</BODY></HTML>
